/******************************************************************************
	filename:		sys_cerrorhandler.h
	date:			04/Nov/2000.
	author:			Bernardo Quiroga.
	contact at:		bernardo_quiroga@hotmail.com, ICQ UIN: 13639620.
	website:		http://www.casema.net/~drago/projects/mango/index.html
	---------------------------------------------------------------------------
	This file is part of "Mango".
	
	This class handles any error that might pop up.
******************************************************************************/
#ifndef __SYS_CERRORHANDLER_H__
#define __SYS_CERRORHANDLER_H__

///////////////////////////////////////////////////////////////////////////////
// Included header files
#include <windows.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <time.h>
#include "dll_interface.h"
#include "sys_typedefs.h"
#include "sys_macros.h"

///////////////////////////////////////////////////////////////////////////////
// Definitions
#define DEFAULT_LOG_FILENAME		"errors.log"
#define DEFAULT_MODE_OF_PROCESSING	1

///////////////////////////////////////////////////////////////////////////////
// Class sys_cerrorhandler
class DLL_INTERFACE sys_cerrorhandler
{
public:
	sys_cerrorhandler();
	sys_cerrorhandler(const bool& bLogAndQuit, const string& strLogFilename);
	virtual ~sys_cerrorhandler();

	void		SetProcessMode(const bool& bLogAndQuit)
				{m_bLogAndQuit = bLogAndQuit;};
	static void	SetError(const string& strErrorMessage);
	void		Process(const string& strFilename, const uint& nLine);
	void		Reset();
protected:
	void		Log(const string& strFilename, const uint& nLine);
	string		GenerateErrorMessage(const string& strFilename,
									 const uint& nLine);
	void		ShowErrorDialog(const string& strFilename, const uint& nLine);

protected:
	bool			m_bLogAndQuit;
	static string	m_strErrorMessage;
	string			m_strLogFilename;
private:
	bool			m_bLogFailed;
};

#endif // __SYS_CERRORHANDLER_H__

///////////////////////////////////////////////////////////////////////////////
// sys_cerrorhandler.h - End of file.
///////////////////////////////////////////////////////////////////////////////
